# Poco

# class DigestEngine

Library: Foundation
Package: Crypt
Header: Poco/DigestEngine.h

## Description

This class is an abstract base class for all classes implementing a message digest algorithm, like MD5Engine and SHA1Engine. Call update() repeatedly with data to compute the digest from. When done, call digest() to obtain the message digest.

## Inheritance

Known Derived Classes: Poco::Crypto::DigestEngine, Poco::Crypto::ECDSADigestEngine, Poco::Crypto::RSADigestEngine, HMACEngine, MD4Engine, MD5Engine, PBKDF2Engine, SHA1Engine, SHA2Engine, SHA2Engine224, SHA2Engine256, SHA2Engine384, SHA2Engine512

## Member Summary

Member Functions: constantTimeEquals, digest, digestFromHex, digestLength, digestToHex, reset, update, updateImpl

## Types Aliases

### Digest

using Digest = std::vector < unsigned char >;

## Constructors

### DigestEngine

DigestEngine();

## Destructor

### ~DigestEngine

virtual ~DigestEngine();

## Member Functions

### constantTimeEquals

static bool constantTimeEquals(
const Digest & d1,
const Digest & d2
);

Compares two Digest values using a constant-time comparison algorithm. This can be used to prevent timing attacks (as discussed in <https://codahale.com/a-lesson-in-timing-attacks/>).

### digest

virtual const Digest & digest() = 0;

Finishes the computation of the digest and returns the message digest. Resets the engine and can thus only be called once for every digest. The returned reference is valid until the next time digest() is called, or the engine object is destroyed.

### digestFromHex

static Digest digestFromHex(
const std::string & digest
);

Converts a string created by digestToHex back to its Digest presentation

### digestLength

virtual std::size_t digestLength() const = 0;

Returns the length of the digest in bytes.

### digestToHex

static std::string digestToHex(
const Digest & bytes,
std::size_t length = 0
);

Converts a message digest into a string of hexadecimal numbers. If length is greater than zero, the output is truncated to length bytes. If size is greater than the length of untruncated output, InvalidArgumentException is thrown.

### reset

virtual void reset() = 0;

Resets the engine so that a new digest can be computed.

### update

void update(
const void * data,
std::size_t length
);

### update

void update(
char data
);

### update

void update(
const std::string & data
);

Updates the digest with the given data.

### updateImpl

virtual void updateImpl(
const void * data,
std::size_t length
) = 0;

Updates the digest with the given data. Must be implemented by subclasses.